diff --git a/src/src/functions.h b/src/src/functions.h
index cdf97f8bd..afb6fd46f 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -444,6 +444,7 @@ extern BOOL    receive_check_set_sender(const uschar *);
 extern BOOL    receive_msg(BOOL);
 extern int_eximarith_t receive_statvfs(BOOL, int *);
 extern void    receive_swallow_smtp(void);
+extern int     recv_fd_from_sock(int);
 #ifdef WITH_CONTENT_SCAN
 extern int     regex(const uschar **, BOOL);
 extern void    regex_vars_clear(void);
@@ -497,6 +498,7 @@ extern int     search_findtype_partial(const uschar *, int *, const uschar **, i
                  int *, const uschar **);
 extern void   *search_open(const uschar *, int, int, uid_t *, gid_t *);
 extern void    search_tidyup(void);
+extern BOOL    send_fd_over_socket(int, int);
 extern uschar *sender_helo_verified_boolstr(void);
 extern void    set_process_info(const char *, ...) PRINTF_FUNCTION(1,2);
 extern void    sha1_end(hctx *, const uschar *, int, uschar *);
@@ -633,11 +635,6 @@ extern uschar *transport_current_name(void);
 extern void    transport_do_pass_socket(const uschar *, const uschar *,
 		 const uschar *, uschar *, int);
 extern void    transport_init(void);
-extern BOOL    transport_pass_socket(const uschar *, const uschar *, const uschar *, uschar *, int
-#ifndef DISABLE_ESMTP_LIMITS
-			, unsigned, unsigned, unsigned
-#endif
-			);
 extern const uschar *transport_rcpt_address(address_item *, BOOL);
 extern BOOL    transport_set_up_command(const uschar ***, const uschar *,
 		 unsigned, int, address_item *, const uschar *, uschar **);
@@ -1404,6 +1401,19 @@ return poll(&p, 1, tmo_millisec);
 /******************************************************************************/
 /* Client-side smtp log string, for debug */
 
+static inline void
+smtp_debug_cmd_log_init(void)
+{
+#  ifndef DISABLE_CLIENT_CMD_LOG
+int old_pool = store_pool;
+store_pool = POOL_PERM;
+client_cmd_log = string_get_tainted(56, GET_TAINTED);
+*client_cmd_log->s = '\0';
+store_pool = old_pool;
+#  endif
+}
+
+
 static inline void
 smtp_debug_cmd(const uschar * buf, int mode)
 {
@@ -1412,31 +1422,46 @@ HDEBUG(D_transport|D_acl|D_v) debug_printf_indent("  SMTP%c> %s\n",
 
 #  ifndef DISABLE_CLIENT_CMD_LOG
   {
-  int len = Ustrcspn(buf, " \n");
-  int old_pool = store_pool;
+  int len = Ustrcspn(buf, " \n"), old_pool = store_pool;
   store_pool = POOL_PERM;	/* Main pool ACL allocations eg. callouts get released */
   client_cmd_log = string_append_listele_n(client_cmd_log, ':', buf, MIN(len, 8));
   if (mode == SCMD_BUFFER) 
-    {
     client_cmd_log = string_catn(client_cmd_log, US"|", 1); 
-    (void) string_from_gstring(client_cmd_log);
-    }
   else if (mode == SCMD_MORE)
-    {
     client_cmd_log = string_catn(client_cmd_log, US"+", 1);
-    (void) string_from_gstring(client_cmd_log);
-    }
   store_pool = old_pool;
   }
 #  endif
 }
 
 
+/* This might be called both due to callout and then from delivery.
+Use memory that will not be released between those phases.
+*/
+static inline void
+smtp_debug_resp(const uschar * buf)
+{
+#  ifndef DISABLE_CLIENT_CMD_LOG
+int old_pool = store_pool;
+store_pool = POOL_PERM;
+client_cmd_log = string_append_listele_n(client_cmd_log, ':', buf,
+  buf[3] == '-' ? 4 : 3);
+store_pool = old_pool;
+#  endif
+}
+
+
 static inline void
 smtp_debug_cmd_report(void)
 {
 #  ifndef DISABLE_CLIENT_CMD_LOG
-debug_printf("cmdlog: '%s'\n", client_cmd_log ? client_cmd_log->s : US"(unset)");
+if (client_cmd_log && *client_cmd_log->s)
+  {
+  debug_printf("cmdlog: '%Y'\n", client_cmd_log);
+  gstring_reset(client_cmd_log);
+  }
+else
+  debug_printf("cmdlog: (unset)\n");
 #  endif
 }
 
diff --git a/src/src/globals.c b/src/src/globals.c
index c50b7a42e..a4b142bc0 100644
--- a/src/src/globals.c
+++ b/src/src/globals.c
@@ -741,17 +741,24 @@ uid_t   config_uid             = 0;
 
 uint64_t connection_id	       = 0L;
 int     connection_max_messages= -1;
+unsigned continue_flags	       = 0;
+#ifndef DISABLE_ESMTP_LIMITS
+unsigned continue_limit_mail   = 0;
+unsigned continue_limit_rcpt   = 0;
+unsigned continue_limit_rcptdom= 0;
+int	continue_fd	       = -1;
 uschar *continue_proxy_cipher  = NULL;
 BOOL    continue_proxy_dane    = FALSE;
 uschar *continue_proxy_sni     = NULL;
-uschar *continue_hostname      = NULL;
-uschar *continue_host_address  = NULL;
+const uschar *continue_hostname      = NULL;
+const uschar *continue_host_address  = NULL;
+uschar  continue_next_id[MESSAGE_ID_LENGTH +1] = {[0]='\0'};
 int     continue_sequence      = 1;
 uschar *continue_transport     = NULL;
-#ifndef DISABLE_ESMTP_LIMITS
-unsigned continue_limit_mail   = 0;
-unsigned continue_limit_rcpt   = 0;
-unsigned continue_limit_rcptdom= 0;
+#ifndef COMPILE_UTILITY
+open_db *continue_retry_db     = NULL;
+open_db *continue_wait_db      = NULL;
+#endif
 #endif
 
 uschar *csa_status             = NULL;
diff --git a/src/src/globals.h b/src/src/globals.h
index dc9d384db..05c39109e 100644
--- a/src/src/globals.h
+++ b/src/src/globals.h
@@ -445,17 +445,24 @@ extern const uschar *config_main_filelist; /* List of possible config files */
 extern uschar *config_main_filename;   /* File name actually used */
 extern uschar *config_main_directory;  /* Directory where the main config file was found */
 extern uid_t   config_uid;             /* Additional owner */
+extern unsigned continue_flags;	       /* TLS-related info for connection */
+#ifndef DISABLE_ESMTP_LIMITS
+extern unsigned continue_limit_mail;   /* Peer advertised limit */
+extern unsigned continue_limit_rcpt;
+extern unsigned continue_limit_rcptdom;
+#endif
+extern int     continue_fd;	       /* Connection for continuation */
 extern uschar *continue_proxy_cipher;  /* TLS cipher for proxied continued delivery */
 extern BOOL    continue_proxy_dane;    /* proxied conn is DANE */
 extern uschar *continue_proxy_sni;     /* proxied conn SNI */
-extern uschar *continue_hostname;      /* Host for continued delivery */
-extern uschar *continue_host_address;  /* IP address for ditto */
+extern const uschar *continue_hostname;      /* Host for continued delivery */
+extern const uschar *continue_host_address;  /* IP address for ditto */
+extern uschar  continue_next_id[];     /* Next message_id from hintsdb */
 extern int     continue_sequence;      /* Sequence num for continued delivery */
 extern uschar *continue_transport;     /* Transport for continued delivery */
-#ifndef DISABLE_ESMTP_LIMITS
-extern unsigned continue_limit_mail;   /* Peer advertised limit */
-extern unsigned continue_limit_rcpt;
-extern unsigned continue_limit_rcptdom;
+#ifndef COMPILE_UTILITY
+extern open_db *continue_retry_db;     /* Hintsdb for retries */
+extern open_db *continue_wait_db;      /* Hintsdb for wait-transport */
 #endif
 
 
